package cz.cvut.kbss.bookstore.dao;

import cz.cvut.kbss.bookstore.bo.User;
import javax.persistence.NoResultException;
import javax.persistence.NonUniqueResultException;
import org.springframework.stereotype.Component;

/**
 * DAO for users.
 */
@Component
public class UserDao extends BaseDao<User, Long> {

    public UserDao() {
        super(User.class);
    }

    public User findByUsername(String username) {
        try {
        return em.createQuery("SELECT u FROM User u WHERE u.userName = :username", User.class)
                .setParameter("username", username)
                .getSingleResult();        
        } catch (NoResultException e) {
            throw new IllegalArgumentException("User not found : " + username);
        }
    }
}
