package cz.cvut.kbss.bookstore.service;

import cz.cvut.kbss.bookstore.bo.User;
import org.junit.Test;
import org.springframework.beans.factory.annotation.Autowired;

import static org.junit.Assert.assertEquals;

public class UserServiceTest extends AbstractServiceTest {

    @Autowired
    private UserService userService;

    @Test
    public void testAddAndRetrieveUser() {

        String userName = "UserName";
        String passwd = "passwd";
        int age = 18;

        Long id = userService.addUser(userName, passwd, age);
        User userDto = userService.find(id);

        assertEquals(userName, userDto.getUserName());
        assertEquals(age, userDto.getAge());

    }

    @Test
    public void testAddAndRemoveUser() {

        String userName = "UserName";
        String passwd = "passwd";
        int age = 18;

        Long id = userService.addUser(userName, passwd, age);
        assertEquals(1, userService.findAll().size());
        userService.removeById(id);
        assertEquals(0, userService.findAll().size());
    }

}
